﻿

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using _03_2_oop;
using OsobyJmP;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace metody
{
    class Metody
    {
        string radka;
        string[] vstup;
        List<Osoba> osoby = new List<Osoba>();
        int id = 0, id2 = 0, vek = 0, count = 0;
        string jmeno = null, prijmeni = null, povolani = null;

        Osoba osobaRemove = new Osoba(0, "", "", 0, "");
        public SaveFileDialog saveFileDialogS2 = new SaveFileDialog();
        public OpenFileDialog openFileDialogS2 = new OpenFileDialog();


        public void nastav_listBoxAdd(Form1 form, string vstup)
        {
            form.listBoxS.Items.Add(vstup);
        }

        public void nastav_listBoxRemove(Form1 form, string vstup)
        {
            form.listBoxS.Items.Remove(vstup);
        }

        public void nastav_listBoxRemoveAt(Form1 form, int vstup)
        {
            form.listBoxS.Items.RemoveAt(vstup);
        }

        public void nastav_listBoxInsert(Form1 form, int vstup, string vstup2)
        {
            form.listBoxS.Items.Insert(vstup, vstup2);
        }

        public void nastav_listBoxClear(Form1 form)
        {
            form.listBoxS.Items.Clear();
        }

        public void nastav_textBoxIDS(Form1 form, string vstup)
        {
            form.textBoxIDS.Text = vstup;
        }

        public string nastav_textBoxJmenoS(Form1 form)
        {
            return form.textBoxJmenoS.Text;
        }

        public string nastav_textBoxPrijmeniS(Form1 form)
        {
            return form.textBoxPrijmeniS.Text;
        }

        public string nastav_textBoxVekS(Form1 form)
        {
            return form.textBoxVekS.Text;
        }

        public string nastav_textBoxPovolaniS(Form1 form)
        {
            return form.textBoxPovolaniS.Text;
        }


        public void nastav_textBoxSouborS(Form1 form, string vstup)
        {
            form.textBoxSouborS.Text = vstup;

        }

        public void closeS(Form1 form){
            form.Close();
        }



        public void pridej(Form1 form,int id,string jmeno, string prijmeni, int vek, string povolani)
        {
            if (jmeno == "") jmeno = "Nezadáno";
            if (prijmeni == "") prijmeni = "Nezadáno";
            if (povolani == "") povolani = "Nezadáno";

            osoby.Add(new Osoba(id, jmeno, prijmeni, vek, povolani));
            nastav_listBoxAdd(form,id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");

        }

        public void odstran(Form1 form,int id2)
        {
            foreach (Osoba osoba in osoby)
            {
                count++;
                id = osoba.id;
                jmeno = osoba.jmeno;
                prijmeni = osoba.prijmeni;
                povolani = osoba.povolani;
                vek = osoba.vek;
                if (osoba.id == id2)
                {
                    osobaRemove = osoba;
                    osoby.Remove(osobaRemove);
                    nastav_listBoxRemove(form, id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");
                    count = 0;
                    break;
                }
                if ((osoba.id != id2) && count == osoby.Count)
                {
                    MessageBox.Show("Položka nenalezena !");
                    count = 0;
                }
            }
        }

       public void uprav(Form1 form,int id2)
        {
            foreach (Osoba osoba in osoby)
            {
                count++;
                if (osoba.id == id2)
                {
                    jmeno = nastav_textBoxJmenoS(form);
                    prijmeni = nastav_textBoxPrijmeniS(form);
                    int.TryParse(nastav_textBoxVekS(form), out vek);
                    povolani = nastav_textBoxPovolaniS(form);
                    osoba.jmeno = jmeno;
                    osoba.prijmeni = prijmeni;
                    osoba.vek = vek;
                    osoba.povolani = povolani;
                    nastav_listBoxRemoveAt(form,count);
                    nastav_listBoxInsert(form, count, (id2 + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t"));
                    
                    count = 0;
                    break;

                }
                if ((id != id2) && count == osoby.Count)
                {
                    MessageBox.Show("Položka nenalezena !");
                    count = 0;
                }
            }
        }

        public void vymazObsah(Form1 form)
        {
            nastav_listBoxClear(form);
        }

        public void vymazDatabazi()
        {
            osoby.Clear();
        }

        public void nactiObsahZDatabaze(Form1 form)
        {
            id = 0;
            nastav_listBoxClear(form);
            nastav_listBoxAdd(form, "ID\t\t Jméno\t\t Příjmení\t\t Věk\t\t Povolání");
           
            foreach (Osoba osoba in osoby)
            {
                id = osoba.id;
                jmeno = osoba.jmeno;
                prijmeni = osoba.prijmeni;
                povolani = osoba.povolani;
                vek = osoba.vek;
                nastav_listBoxAdd(form, id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");
            }
        }

       public void ulozDoCSV(Form1 form)
        {
            
           // if (_formular.saveFileDialogS.ShowDialog() == DialogResult.OK)
            if (saveFileDialogS2.ShowDialog() == DialogResult.OK)
            {
                
                StreamWriter souborW = new StreamWriter(saveFileDialogS2.FileName);
                //StreamWriter souborW = new StreamWriter(saveFileDialogS2.FileName);
                foreach (Osoba osoba in osoby)
                {
                    souborW.WriteLine(osoba.id + ";" + osoba.jmeno + ";" + osoba.prijmeni + ";" + osoba.vek + ";" + osoba.povolani + ";");
                }
                nastav_textBoxSouborS(form, saveFileDialogS2.FileName.ToString());

                souborW.Close();
            }
        }

      public  void nactiZCSV(Form1 form)
        {
            if (openFileDialogS2.ShowDialog() == DialogResult.OK)
            {
                osoby.Clear();
                nastav_listBoxClear(form);
                StreamReader souborR = new StreamReader(openFileDialogS2.FileName);
                nastav_listBoxAdd(form,"ID\t\t Jméno\t\t Příjmení\t\t Věk\t\t Povolání");
              
                while ((radka = souborR.ReadLine()) != null)
                {
                    vstup = radka.Split(';');
                    if (vstup.Length == 6)
                    {
                        int.TryParse(vstup[0], out id);
                        jmeno = vstup[1];
                        prijmeni = vstup[2];
                        int.TryParse(vstup[3], out vek);
                        povolani = vstup[4];
                        osoby.Add(new Osoba(id, jmeno, prijmeni, vek, povolani));
                        nastav_listBoxAdd(form,id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");
                        
                    }
                    else
                    {
                        osoby.Clear();
                        nastav_listBoxClear(form);
                        nastav_textBoxSouborS(form, null);
                         MessageBox.Show(" Data nelze načíst ! !");
                        nastav_textBoxSouborS(form, "Neplatný formát ! " + openFileDialogS2.FileName.ToString());
                        break;
                    }
                }
                if (vstup.Length == 6) nastav_textBoxSouborS(form,openFileDialogS2.FileName.ToString());
                    
                souborR.Close();
            }
        }

       public void ukonciProgram(Form1 form)
        {
            closeS(form);
        }

       public void zobrazInformaceOAutorovi()
        {
            MessageBox.Show("Databáze V2.0 Autor David Tomek 17.9.2024 https://home.spsostrov.cz/~tomeda/ , unixuser@seznam.cz");
        }
    }

}
